#include <glib.h>
#include <glib-object.h>
#include "dialing.h"
#define DIALING_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), TYPE_DIALING, DialingPrivate))
enum
{
	PROP_0, /* unused property */
	PROP_DEVICE,
	PROP_DIAL_COMMAND,
	PROP_INIT1,
	PROP_INIT2,
	PROP_INIT3,
	PROP_INIT4,
	PROP_INIT5,
	PROP_INIT6,
	PROP_INIT7,
	PROP_INIT8,
	PROP_INIT9,
	PROP_LOGIN,
	PROP_NAME,
	PROP_PASSWORD,
	PROP_PHONE,
	PROP_SPEED,
	PROP_STUPID,
	PROP_TYPE,
	PROP_VOLUME,
	PROP_1 /* unused property */
};
struct _DialingPrivate {
	gchar* device;
	gchar* dial_command;
	gchar* init1;
	gchar* init2;
	gchar* init3;
	gchar* init4;
	gchar* init5;
	gchar* init6;
	gchar* init7;
	gchar* init8;
	gchar* init9;
	gchar* login;
	gchar* name;
	gchar* password;
	gchar* phone;
	gchar* speed;
	gchar* stupid;
	gchar* type;
	gchar* volume;
};

/* Parent class */
static GObjectClass *parent_class = NULL;
/* Prototypes definition */
static void dialing_init (Dialing*obj);
static void dialing_class_init (DialingClass*obj);
static void dialing_finalize (GObject* object);
static void dialing_set_property (GObject *object, guint prop_id, const GValue *value, GParamSpec *pspec);
static void dialing_get_property (GObject *object, guint prop_id, GValue *value, GParamSpec *pspec);

GType
dialing_get_type (void)
{
	static GType object_type = 0;
	if (!object_type) {
		static const GTypeInfo object_info =
		{
			sizeof (DialingClass),
			NULL, /* base init */
			NULL, /* base finalize */
			(GClassInitFunc) dialing_class_init,
			NULL, /* class finalize */
			NULL, /* class data */
			sizeof (Dialing),
			0, /* number of pre-allocs */
			(GInstanceInitFunc) dialing_init,
		};
		object_type = g_type_register_static (G_TYPE_OBJECT, "Dialing", &object_info, 0);
	}
	return object_type;
}

static void
dialing_class_init (DialingClass *klass)
{
	GObjectClass *gobject_class;
	parent_class = g_type_class_peek_parent (klass);
	gobject_class = G_OBJECT_CLASS (klass);
	gobject_class->finalize = dialing_finalize;
	gobject_class->set_property = dialing_set_property;
	gobject_class->get_property = dialing_get_property;
	g_object_class_install_property (gobject_class,
			PROP_DEVICE,
			g_param_spec_string ("device", "device", "device", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_DIAL_COMMAND,
			g_param_spec_string ("dial_command", "dial_command", "dial_command", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT1,
			g_param_spec_string ("init1", "init1", "init1", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT2,
			g_param_spec_string ("init2", "init2", "init2", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT3,
			g_param_spec_string ("init3", "init3", "init3", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT4,
			g_param_spec_string ("init4", "init4", "init4", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT5,
			g_param_spec_string ("init5", "init5", "init5", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT6,
			g_param_spec_string ("init6", "init6", "init6", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT7,
			g_param_spec_string ("init7", "init7", "init7", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT8,
			g_param_spec_string ("init8", "init8", "init8", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_INIT9,
			g_param_spec_string ("init9", "init9", "init9", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_LOGIN,
			g_param_spec_string ("login", "login", "login", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_NAME,
			g_param_spec_string ("name", "name", "name", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_PASSWORD,
			g_param_spec_string ("password", "password", "password", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_PHONE,
			g_param_spec_string ("phone", "phone", "phone", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_SPEED,
			g_param_spec_string ("speed", "speed", "speed", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_STUPID,
			g_param_spec_string ("stupid", "stupid", "stupid", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_TYPE,
			g_param_spec_string ("type", "type", "type", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_VOLUME,
			g_param_spec_string ("volume", "volume", "volume", NULL, G_PARAM_READWRITE));
	g_type_class_add_private (gobject_class, sizeof (DialingPrivate));
}

static void
dialing_init (Dialing *object)
{
	object->private_data = DIALING_GET_PRIVATE (object);
	object->private_data->device = NULL;
	object->private_data->dial_command = NULL;
	object->private_data->init1 = NULL;
	object->private_data->init2 = NULL;
	object->private_data->init3 = NULL;
	object->private_data->init4 = NULL;
	object->private_data->init5 = NULL;
	object->private_data->init6 = NULL;
	object->private_data->init7 = NULL;
	object->private_data->init8 = NULL;
	object->private_data->init9 = NULL;
	object->private_data->login = NULL;
	object->private_data->name = NULL;
	object->private_data->password = NULL;
	object->private_data->phone = NULL;
	object->private_data->speed = NULL;
	object->private_data->stupid = NULL;
	object->private_data->type = NULL;
	object->private_data->volume = NULL;
}

static void
dialing_set_property (GObject *object, guint prop_id, const GValue *value, GParamSpec *pspec)
{
	Dialing *self;
	gchar tmp;
	self = DIALING (object);
	switch (prop_id) {
		case PROP_DEVICE:
			dialing_set_device (self, g_value_get_string(value));
			break;
		case PROP_DIAL_COMMAND:
			dialing_set_dial_command (self, g_value_get_string(value));
			break;
		case PROP_INIT1:
			dialing_set_init1 (self, g_value_get_string(value));
			break;
		case PROP_INIT2:
			dialing_set_init2 (self, g_value_get_string(value));
			break;
		case PROP_INIT3:
			dialing_set_init3 (self, g_value_get_string(value));
			break;
		case PROP_INIT4:
			dialing_set_init4 (self, g_value_get_string(value));
			break;
		case PROP_INIT5:
			dialing_set_init5 (self, g_value_get_string(value));
			break;
		case PROP_INIT6:
			dialing_set_init6 (self, g_value_get_string(value));
			break;
		case PROP_INIT7:
			dialing_set_init7 (self, g_value_get_string(value));
			break;
		case PROP_INIT8:
			dialing_set_init8 (self, g_value_get_string(value));
			break;
		case PROP_INIT9:
			dialing_set_init9 (self, g_value_get_string(value));
			break;
		case PROP_LOGIN:
			dialing_set_login (self, g_value_get_string(value));
			break;
		case PROP_NAME:
			dialing_set_name (self, g_value_get_string(value));
			break;
		case PROP_PASSWORD:
			dialing_set_password (self, g_value_get_string(value));
			break;
		case PROP_PHONE:
			dialing_set_phone (self, g_value_get_string(value));
			break;
		case PROP_SPEED:
			dialing_set_speed (self, g_value_get_string(value));
			break;
		case PROP_STUPID:
			dialing_set_stupid (self, g_value_get_string(value));
			break;
		case PROP_TYPE:
			dialing_set_type (self, g_value_get_string(value));
			break;
		case PROP_VOLUME:
			dialing_set_volume (self, g_value_get_string(value));
			break;
		default:
			G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
			break;
	}
}

static void
dialing_get_property (GObject *object, guint prop_id, GValue *value, GParamSpec *pspec)
{
	Dialing *self;
	self = DIALING (object);
	switch (prop_id) {
		case PROP_DEVICE:
			g_value_set_string (value, dialing_get_device (self));
			break;
		case PROP_DIAL_COMMAND:
			g_value_set_string (value, dialing_get_dial_command (self));
			break;
		case PROP_INIT1:
			g_value_set_string (value, dialing_get_init1 (self));
			break;
		case PROP_INIT2:
			g_value_set_string (value, dialing_get_init2 (self));
			break;
		case PROP_INIT3:
			g_value_set_string (value, dialing_get_init3 (self));
			break;
		case PROP_INIT4:
			g_value_set_string (value, dialing_get_init4 (self));
			break;
		case PROP_INIT5:
			g_value_set_string (value, dialing_get_init5 (self));
			break;
		case PROP_INIT6:
			g_value_set_string (value, dialing_get_init6 (self));
			break;
		case PROP_INIT7:
			g_value_set_string (value, dialing_get_init7 (self));
			break;
		case PROP_INIT8:
			g_value_set_string (value, dialing_get_init8 (self));
			break;
		case PROP_INIT9:
			g_value_set_string (value, dialing_get_init9 (self));
			break;
		case PROP_LOGIN:
			g_value_set_string (value, dialing_get_login (self));
			break;
		case PROP_NAME:
			g_value_set_string (value, dialing_get_name (self));
			break;
		case PROP_PASSWORD:
			g_value_set_string (value, dialing_get_password (self));
			break;
		case PROP_PHONE:
			g_value_set_string (value, dialing_get_phone (self));
			break;
		case PROP_SPEED:
			g_value_set_string (value, dialing_get_speed (self));
			break;
		case PROP_STUPID:
			g_value_set_string (value, dialing_get_stupid (self));
			break;
		case PROP_TYPE:
			g_value_set_string (value, dialing_get_type (self));
			break;
		case PROP_VOLUME:
			g_value_set_string (value, dialing_get_volume (self));
			break;
		default:
			G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
	}
}

Dialing*
dialing_new (void)
{
	Dialing* ret;
	ret = g_object_new (TYPE_DIALING, NULL);
	g_assert (ret);
	return ret;
}

static void
dialing_finalize (GObject *object)
{
	/* cast to this type */
	Dialing* self;
	GList *list;
	self = DIALING(object);
	g_free (self->private_data->device);
	g_free (self->private_data->dial_command);
	g_free (self->private_data->init1);
	g_free (self->private_data->init2);
	g_free (self->private_data->init3);
	g_free (self->private_data->init4);
	g_free (self->private_data->init5);
	g_free (self->private_data->init6);
	g_free (self->private_data->init7);
	g_free (self->private_data->init8);
	g_free (self->private_data->init9);
	g_free (self->private_data->login);
	g_free (self->private_data->name);
	g_free (self->private_data->password);
	g_free (self->private_data->phone);
	g_free (self->private_data->speed);
	g_free (self->private_data->stupid);
	g_free (self->private_data->type);
	g_free (self->private_data->volume);
}

gchar*
dialing_get_device (Dialing* self)
{
	g_assert (self);
	return self->private_data->device;
}

void
dialing_set_device (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->device);
	self->private_data->device = tmp;
}

gchar*
dialing_get_dial_command (Dialing* self)
{
	g_assert (self);
	return self->private_data->dial_command;
}

void
dialing_set_dial_command (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->dial_command);
	self->private_data->dial_command = tmp;
}

gchar*
dialing_get_init1 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init1;
}

void
dialing_set_init1 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init1);
	self->private_data->init1 = tmp;
}

gchar*
dialing_get_init2 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init2;
}

void
dialing_set_init2 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init2);
	self->private_data->init2 = tmp;
}

gchar*
dialing_get_init3 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init3;
}

void
dialing_set_init3 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init3);
	self->private_data->init3 = tmp;
}

gchar*
dialing_get_init4 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init4;
}

void
dialing_set_init4 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init4);
	self->private_data->init4 = tmp;
}

gchar*
dialing_get_init5 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init5;
}

void
dialing_set_init5 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init5);
	self->private_data->init5 = tmp;
}

gchar*
dialing_get_init6 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init6;
}

void
dialing_set_init6 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init6);
	self->private_data->init6 = tmp;
}

gchar*
dialing_get_init7 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init7;
}

void
dialing_set_init7 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init7);
	self->private_data->init7 = tmp;
}

gchar*
dialing_get_init8 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init8;
}

void
dialing_set_init8 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init8);
	self->private_data->init8 = tmp;
}

gchar*
dialing_get_init9 (Dialing* self)
{
	g_assert (self);
	return self->private_data->init9;
}

void
dialing_set_init9 (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->init9);
	self->private_data->init9 = tmp;
}

gchar*
dialing_get_login (Dialing* self)
{
	g_assert (self);
	return self->private_data->login;
}

void
dialing_set_login (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->login);
	self->private_data->login = tmp;
}

gchar*
dialing_get_name (Dialing* self)
{
	g_assert (self);
	return self->private_data->name;
}

void
dialing_set_name (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->name);
	self->private_data->name = tmp;
}

gchar*
dialing_get_password (Dialing* self)
{
	g_assert (self);
	return self->private_data->password;
}

void
dialing_set_password (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->password);
	self->private_data->password = tmp;
}

gchar*
dialing_get_phone (Dialing* self)
{
	g_assert (self);
	return self->private_data->phone;
}

void
dialing_set_phone (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->phone);
	self->private_data->phone = tmp;
}

gchar*
dialing_get_speed (Dialing* self)
{
	g_assert (self);
	return self->private_data->speed;
}

void
dialing_set_speed (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->speed);
	self->private_data->speed = tmp;
}

gchar*
dialing_get_stupid (Dialing* self)
{
	g_assert (self);
	return self->private_data->stupid;
}

void
dialing_set_stupid (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->stupid);
	self->private_data->stupid = tmp;
}

gchar*
dialing_get_type (Dialing* self)
{
	g_assert (self);
	return self->private_data->type;
}

void
dialing_set_type (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->type);
	self->private_data->type = tmp;
}

gchar*
dialing_get_volume (Dialing* self)
{
	g_assert (self);
	return self->private_data->volume;
}

void
dialing_set_volume (Dialing* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->volume);
	self->private_data->volume = tmp;
}

