#include <glib.h>
#include <glib-object.h>
#include "interface.h"
#define INTERFACE_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), TYPE_INTERFACE, InterfacePrivate))
enum
{
	PROP_0, /* unused property */
	PROP_ADDRESS,
	PROP_AUTO,
	PROP_BOOTPROTO,
	PROP_BROADCAST,
	PROP_DEBUG,
	PROP_DEV,
	PROP_ENABLED,
	PROP_FILE,
	PROP_GATEWAY,
	PROP_NAME,
	PROP_NETMASK,
	PROP_NETWORK,
	PROP_NOAUTH,
	PROP_PERSIST,
	PROP_SERIAL_HWCTL,
	PROP_SERIAL_PORT,
	PROP_SET_DEFAULT_GW,
	PROP_UPDATE_DNS,
	PROP_USER,
	PROP_WVSECTION,
	PROP_1 /* unused property */
};
struct _InterfacePrivate {
	gchar* address;
	gint auto;
	gchar* bootproto;
	gchar* broadcast;
	gchar* debug;
	gchar* dev;
	gint enabled;
	gchar* file;
	gchar* gateway;
	gchar* name;
	gchar* netmask;
	gchar* network;
	gchar* noauth;
	gchar* persist;
	gchar* serial_hwctl;
	gchar* serial_port;
	gchar* set_default_gw;
	gint update_dns;
	gint user;
	gchar* wvsection;
};

/* Parent class */
static GObjectClass *parent_class = NULL;
/* Prototypes definition */
static void interface_init (Interface*obj);
static void interface_class_init (InterfaceClass*obj);
static void interface_finalize (GObject* object);
static void interface_set_property (GObject *object, guint prop_id, const GValue *value, GParamSpec *pspec);
static void interface_get_property (GObject *object, guint prop_id, GValue *value, GParamSpec *pspec);

GType
interface_get_type (void)
{
	static GType object_type = 0;
	if (!object_type) {
		static const GTypeInfo object_info =
		{
			sizeof (InterfaceClass),
			NULL, /* base init */
			NULL, /* base finalize */
			(GClassInitFunc) interface_class_init,
			NULL, /* class finalize */
			NULL, /* class data */
			sizeof (Interface),
			0, /* number of pre-allocs */
			(GInstanceInitFunc) interface_init,
		};
		object_type = g_type_register_static (G_TYPE_OBJECT, "Interface", &object_info, 0);
	}
	return object_type;
}

static void
interface_class_init (InterfaceClass *klass)
{
	GObjectClass *gobject_class;
	parent_class = g_type_class_peek_parent (klass);
	gobject_class = G_OBJECT_CLASS (klass);
	gobject_class->finalize = interface_finalize;
	gobject_class->set_property = interface_set_property;
	gobject_class->get_property = interface_get_property;
	g_object_class_install_property (gobject_class,
			PROP_ADDRESS,
			g_param_spec_string ("address", "address", "address", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_AUTO,
			g_param_spec_int ("auto", "auto", "auto", G_MININT, G_MAXINT, 0, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_BOOTPROTO,
			g_param_spec_string ("bootproto", "bootproto", "bootproto", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_BROADCAST,
			g_param_spec_string ("broadcast", "broadcast", "broadcast", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_DEBUG,
			g_param_spec_string ("debug", "debug", "debug", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_DEV,
			g_param_spec_string ("dev", "dev", "dev", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_ENABLED,
			g_param_spec_int ("enabled", "enabled", "enabled", G_MININT, G_MAXINT, 0, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_FILE,
			g_param_spec_string ("file", "file", "file", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_GATEWAY,
			g_param_spec_string ("gateway", "gateway", "gateway", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_NAME,
			g_param_spec_string ("name", "name", "name", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_NETMASK,
			g_param_spec_string ("netmask", "netmask", "netmask", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_NETWORK,
			g_param_spec_string ("network", "network", "network", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_NOAUTH,
			g_param_spec_string ("noauth", "noauth", "noauth", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_PERSIST,
			g_param_spec_string ("persist", "persist", "persist", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_SERIAL_HWCTL,
			g_param_spec_string ("serial_hwctl", "serial_hwctl", "serial_hwctl", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_SERIAL_PORT,
			g_param_spec_string ("serial_port", "serial_port", "serial_port", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_SET_DEFAULT_GW,
			g_param_spec_string ("set_default_gw", "set_default_gw", "set_default_gw", NULL, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_UPDATE_DNS,
			g_param_spec_int ("update_dns", "update_dns", "update_dns", G_MININT, G_MAXINT, 0, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_USER,
			g_param_spec_int ("user", "user", "user", G_MININT, G_MAXINT, 0, G_PARAM_READWRITE));
	g_object_class_install_property (gobject_class,
			PROP_WVSECTION,
			g_param_spec_string ("wvsection", "wvsection", "wvsection", NULL, G_PARAM_READWRITE));
	g_type_class_add_private (gobject_class, sizeof (InterfacePrivate));
}

static void
interface_init (Interface *object)
{
	object->private_data = INTERFACE_GET_PRIVATE (object);
	object->private_data->address = NULL;
	object->private_data->bootproto = NULL;
	object->private_data->broadcast = NULL;
	object->private_data->debug = NULL;
	object->private_data->dev = NULL;
	object->private_data->file = NULL;
	object->private_data->gateway = NULL;
	object->private_data->name = NULL;
	object->private_data->netmask = NULL;
	object->private_data->network = NULL;
	object->private_data->noauth = NULL;
	object->private_data->persist = NULL;
	object->private_data->serial_hwctl = NULL;
	object->private_data->serial_port = NULL;
	object->private_data->set_default_gw = NULL;
	object->private_data->wvsection = NULL;
}

static void
interface_set_property (GObject *object, guint prop_id, const GValue *value, GParamSpec *pspec)
{
	Interface *self;
	gchar tmp;
	self = INTERFACE (object);
	switch (prop_id) {
		case PROP_ADDRESS:
			interface_set_address (self, g_value_get_string(value));
			break;
		case PROP_AUTO:
			interface_set_auto (self, g_value_get_int(value));
			break;
		case PROP_BOOTPROTO:
			interface_set_bootproto (self, g_value_get_string(value));
			break;
		case PROP_BROADCAST:
			interface_set_broadcast (self, g_value_get_string(value));
			break;
		case PROP_DEBUG:
			interface_set_debug (self, g_value_get_string(value));
			break;
		case PROP_DEV:
			interface_set_dev (self, g_value_get_string(value));
			break;
		case PROP_ENABLED:
			interface_set_enabled (self, g_value_get_int(value));
			break;
		case PROP_FILE:
			interface_set_file (self, g_value_get_string(value));
			break;
		case PROP_GATEWAY:
			interface_set_gateway (self, g_value_get_string(value));
			break;
		case PROP_NAME:
			interface_set_name (self, g_value_get_string(value));
			break;
		case PROP_NETMASK:
			interface_set_netmask (self, g_value_get_string(value));
			break;
		case PROP_NETWORK:
			interface_set_network (self, g_value_get_string(value));
			break;
		case PROP_NOAUTH:
			interface_set_noauth (self, g_value_get_string(value));
			break;
		case PROP_PERSIST:
			interface_set_persist (self, g_value_get_string(value));
			break;
		case PROP_SERIAL_HWCTL:
			interface_set_serial_hwctl (self, g_value_get_string(value));
			break;
		case PROP_SERIAL_PORT:
			interface_set_serial_port (self, g_value_get_string(value));
			break;
		case PROP_SET_DEFAULT_GW:
			interface_set_set_default_gw (self, g_value_get_string(value));
			break;
		case PROP_UPDATE_DNS:
			interface_set_update_dns (self, g_value_get_int(value));
			break;
		case PROP_USER:
			interface_set_user (self, g_value_get_int(value));
			break;
		case PROP_WVSECTION:
			interface_set_wvsection (self, g_value_get_string(value));
			break;
		default:
			G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
			break;
	}
}

static void
interface_get_property (GObject *object, guint prop_id, GValue *value, GParamSpec *pspec)
{
	Interface *self;
	self = INTERFACE (object);
	switch (prop_id) {
		case PROP_ADDRESS:
			g_value_set_string (value, interface_get_address (self));
			break;
		case PROP_AUTO:
			g_value_set_int (value, interface_get_auto (self));
			break;
		case PROP_BOOTPROTO:
			g_value_set_string (value, interface_get_bootproto (self));
			break;
		case PROP_BROADCAST:
			g_value_set_string (value, interface_get_broadcast (self));
			break;
		case PROP_DEBUG:
			g_value_set_string (value, interface_get_debug (self));
			break;
		case PROP_DEV:
			g_value_set_string (value, interface_get_dev (self));
			break;
		case PROP_ENABLED:
			g_value_set_int (value, interface_get_enabled (self));
			break;
		case PROP_FILE:
			g_value_set_string (value, interface_get_file (self));
			break;
		case PROP_GATEWAY:
			g_value_set_string (value, interface_get_gateway (self));
			break;
		case PROP_NAME:
			g_value_set_string (value, interface_get_name (self));
			break;
		case PROP_NETMASK:
			g_value_set_string (value, interface_get_netmask (self));
			break;
		case PROP_NETWORK:
			g_value_set_string (value, interface_get_network (self));
			break;
		case PROP_NOAUTH:
			g_value_set_string (value, interface_get_noauth (self));
			break;
		case PROP_PERSIST:
			g_value_set_string (value, interface_get_persist (self));
			break;
		case PROP_SERIAL_HWCTL:
			g_value_set_string (value, interface_get_serial_hwctl (self));
			break;
		case PROP_SERIAL_PORT:
			g_value_set_string (value, interface_get_serial_port (self));
			break;
		case PROP_SET_DEFAULT_GW:
			g_value_set_string (value, interface_get_set_default_gw (self));
			break;
		case PROP_UPDATE_DNS:
			g_value_set_int (value, interface_get_update_dns (self));
			break;
		case PROP_USER:
			g_value_set_int (value, interface_get_user (self));
			break;
		case PROP_WVSECTION:
			g_value_set_string (value, interface_get_wvsection (self));
			break;
		default:
			G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
	}
}

Interface*
interface_new (void)
{
	Interface* ret;
	ret = g_object_new (TYPE_INTERFACE, NULL);
	g_assert (ret);
	return ret;
}

static void
interface_finalize (GObject *object)
{
	/* cast to this type */
	Interface* self;
	GList *list;
	self = INTERFACE(object);
	g_free (self->private_data->address);
	g_free (self->private_data->bootproto);
	g_free (self->private_data->broadcast);
	g_free (self->private_data->debug);
	g_free (self->private_data->dev);
	g_free (self->private_data->file);
	g_free (self->private_data->gateway);
	g_free (self->private_data->name);
	g_free (self->private_data->netmask);
	g_free (self->private_data->network);
	g_free (self->private_data->noauth);
	g_free (self->private_data->persist);
	g_free (self->private_data->serial_hwctl);
	g_free (self->private_data->serial_port);
	g_free (self->private_data->set_default_gw);
	g_free (self->private_data->wvsection);
}

gchar*
interface_get_address (Interface* self)
{
	g_assert (self);
	return self->private_data->address;
}

void
interface_set_address (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->address);
	self->private_data->address = tmp;
}

gint
interface_get_auto (Interface* self)
{
	g_assert (self);
	return self->private_data->auto;
}

void
interface_set_auto (Interface* self, gint data)
{
	g_assert(self);
	self->private_data->auto = data;
}

gchar*
interface_get_bootproto (Interface* self)
{
	g_assert (self);
	return self->private_data->bootproto;
}

void
interface_set_bootproto (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->bootproto);
	self->private_data->bootproto = tmp;
}

gchar*
interface_get_broadcast (Interface* self)
{
	g_assert (self);
	return self->private_data->broadcast;
}

void
interface_set_broadcast (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->broadcast);
	self->private_data->broadcast = tmp;
}

gchar*
interface_get_debug (Interface* self)
{
	g_assert (self);
	return self->private_data->debug;
}

void
interface_set_debug (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->debug);
	self->private_data->debug = tmp;
}

gchar*
interface_get_dev (Interface* self)
{
	g_assert (self);
	return self->private_data->dev;
}

void
interface_set_dev (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->dev);
	self->private_data->dev = tmp;
}

gint
interface_get_enabled (Interface* self)
{
	g_assert (self);
	return self->private_data->enabled;
}

void
interface_set_enabled (Interface* self, gint data)
{
	g_assert(self);
	self->private_data->enabled = data;
}

gchar*
interface_get_file (Interface* self)
{
	g_assert (self);
	return self->private_data->file;
}

void
interface_set_file (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->file);
	self->private_data->file = tmp;
}

gchar*
interface_get_gateway (Interface* self)
{
	g_assert (self);
	return self->private_data->gateway;
}

void
interface_set_gateway (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->gateway);
	self->private_data->gateway = tmp;
}

gchar*
interface_get_name (Interface* self)
{
	g_assert (self);
	return self->private_data->name;
}

void
interface_set_name (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->name);
	self->private_data->name = tmp;
}

gchar*
interface_get_netmask (Interface* self)
{
	g_assert (self);
	return self->private_data->netmask;
}

void
interface_set_netmask (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->netmask);
	self->private_data->netmask = tmp;
}

gchar*
interface_get_network (Interface* self)
{
	g_assert (self);
	return self->private_data->network;
}

void
interface_set_network (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->network);
	self->private_data->network = tmp;
}

gchar*
interface_get_noauth (Interface* self)
{
	g_assert (self);
	return self->private_data->noauth;
}

void
interface_set_noauth (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->noauth);
	self->private_data->noauth = tmp;
}

gchar*
interface_get_persist (Interface* self)
{
	g_assert (self);
	return self->private_data->persist;
}

void
interface_set_persist (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->persist);
	self->private_data->persist = tmp;
}

gchar*
interface_get_serial_hwctl (Interface* self)
{
	g_assert (self);
	return self->private_data->serial_hwctl;
}

void
interface_set_serial_hwctl (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->serial_hwctl);
	self->private_data->serial_hwctl = tmp;
}

gchar*
interface_get_serial_port (Interface* self)
{
	g_assert (self);
	return self->private_data->serial_port;
}

void
interface_set_serial_port (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->serial_port);
	self->private_data->serial_port = tmp;
}

gchar*
interface_get_set_default_gw (Interface* self)
{
	g_assert (self);
	return self->private_data->set_default_gw;
}

void
interface_set_set_default_gw (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->set_default_gw);
	self->private_data->set_default_gw = tmp;
}

gint
interface_get_update_dns (Interface* self)
{
	g_assert (self);
	return self->private_data->update_dns;
}

void
interface_set_update_dns (Interface* self, gint data)
{
	g_assert(self);
	self->private_data->update_dns = data;
}

gint
interface_get_user (Interface* self)
{
	g_assert (self);
	return self->private_data->user;
}

void
interface_set_user (Interface* self, gint data)
{
	g_assert(self);
	self->private_data->user = data;
}

gchar*
interface_get_wvsection (Interface* self)
{
	g_assert (self);
	return self->private_data->wvsection;
}

void
interface_set_wvsection (Interface* self, const gchar* data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free (self->private_data->wvsection);
	self->private_data->wvsection = tmp;
}

