#ifndef __INTERFACE_H__
#define __INTERFACE_H__
#include <glib.h>
#include <glib-object.h>
#define TYPE_INTERFACE (interface_get_type())
#define INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INTERFACE, Interface))
#define INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INTERFACE, InterfaceClass))
#define IS_INTERFACE(obj) (G_TYPE_CHECK_TYPE ((obj), TYPE_INTERFACE))
#define IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),TYPE_INTERFACE))
#define INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INTERFACE, InterfaceClass))
/* Object/Class definition */
typedef struct _Interface Interface;
typedef struct _InterfacePrivate InterfacePrivate;
typedef struct _InterfaceClass InterfaceClass;

/* Object structure */
struct _InterfaceClass {
	GObjectClass parent_class;
	/* private functions */
};

/* Class structure */
struct _Interface {
	GObject object;
	/* private data */
	InterfacePrivate *private_data;
};

/* used by data type */
GType interface_get_type (void);

/* Object methods */
Interface* interface_new (void);
gchar* interface_get_address (Interface *self);
void interface_set_address (Interface *self, const gchar* data);
gint interface_get_auto (Interface *self);
void interface_set_auto (Interface *self, gint data);
gchar* interface_get_bootproto (Interface *self);
void interface_set_bootproto (Interface *self, const gchar* data);
gchar* interface_get_broadcast (Interface *self);
void interface_set_broadcast (Interface *self, const gchar* data);
gchar* interface_get_debug (Interface *self);
void interface_set_debug (Interface *self, const gchar* data);
gchar* interface_get_dev (Interface *self);
void interface_set_dev (Interface *self, const gchar* data);
gint interface_get_enabled (Interface *self);
void interface_set_enabled (Interface *self, gint data);
gchar* interface_get_file (Interface *self);
void interface_set_file (Interface *self, const gchar* data);
gchar* interface_get_gateway (Interface *self);
void interface_set_gateway (Interface *self, const gchar* data);
gchar* interface_get_name (Interface *self);
void interface_set_name (Interface *self, const gchar* data);
gchar* interface_get_netmask (Interface *self);
void interface_set_netmask (Interface *self, const gchar* data);
gchar* interface_get_network (Interface *self);
void interface_set_network (Interface *self, const gchar* data);
gchar* interface_get_noauth (Interface *self);
void interface_set_noauth (Interface *self, const gchar* data);
gchar* interface_get_persist (Interface *self);
void interface_set_persist (Interface *self, const gchar* data);
gchar* interface_get_serial_hwctl (Interface *self);
void interface_set_serial_hwctl (Interface *self, const gchar* data);
gchar* interface_get_serial_port (Interface *self);
void interface_set_serial_port (Interface *self, const gchar* data);
gchar* interface_get_set_default_gw (Interface *self);
void interface_set_set_default_gw (Interface *self, const gchar* data);
gint interface_get_update_dns (Interface *self);
void interface_set_update_dns (Interface *self, gint data);
gint interface_get_user (Interface *self);
void interface_set_user (Interface *self, gint data);
gchar* interface_get_wvsection (Interface *self);
void interface_set_wvsection (Interface *self, const gchar* data);
#endif /* header definition */
