#ifndef __NETWORK_H__
#define __NETWORK_H__
#include <glib.h>
#include <glib-object.h>
#define TYPE_NETWORK (network_get_type())
#define NETWORK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NETWORK, Network))
#define NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NETWORK, NetworkClass))
#define IS_NETWORK(obj) (G_TYPE_CHECK_TYPE ((obj), TYPE_NETWORK))
#define IS_NETWORK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),TYPE_NETWORK))
#define NETWORK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NETWORK, NetworkClass))
/* Object/Class definition */
typedef struct _Network Network;
typedef struct _NetworkPrivate NetworkPrivate;
typedef struct _NetworkClass NetworkClass;

/* Object structure */
struct _NetworkClass {
	GObjectClass parent_class;
	/* private functions */
};

/* Class structure */
struct _Network {
	GObject object;
	/* private data */
	NetworkPrivate *private_data;
};

/* used by data type */
GType network_get_type (void);

/* Object methods */
Network* network_new (void);
gchar* network_get_dialinstalled (Network *self);
void network_set_dialinstalled (Network *self, const gchar* data);
gchar* network_get_hostname (Network *self);
void network_set_hostname (Network *self, const gchar* data);
gchar* network_get_smardhcpd (Network *self);
void network_set_smardhcpd (Network *self, const gchar* data);
gchar* network_get_smbdesc (Network *self);
void network_set_smbdesc (Network *self, const gchar* data);
gchar* network_get_smbinstalled (Network *self);
void network_set_smbinstalled (Network *self, const gchar* data);
guchar network_get_smbuse (Network *self);
void network_set_smbuse (Network *self, guchar data);
GList* network_get_interface (Network *self);
void network_set_interface (Network *self, GList* data);
GList* network_get_dialing (Network *self);
void network_set_dialing (Network *self, GList* data);
GList* network_get_order (Network *self);
void network_set_order (Network *self, GList* data);
GList* network_get_statichost (Network *self);
void network_set_statichost (Network *self, GList* data);
#endif /* header definition */
